Index: /ruby/trunk/adl_parser/lib/parser.rb
===================================================================
--- /ruby/trunk/adl_parser/lib/parser.rb	(revision 30)
+++ /ruby/trunk/adl_parser/lib/parser.rb	(revision 20)
@@ -2556,258 +2237,140 @@
  # reduce 95 omitted
 
-module_eval <<'.,.,', 'lib/parser.y', 450
-  def _reduce_96( val, _values, result )
-    result = val[0]
-   result
-  end
-.,.,
-
-module_eval <<'.,.,', 'lib/parser.y', 454
-  def _reduce_97( val, _values, result )
-    result = val[0]
-   result
-  end
-.,.,
-
-module_eval <<'.,.,', 'lib/parser.y', 459
-  def _reduce_98( val, _values, result )
-    result = val[0]
-   result
-  end
-.,.,
-
-module_eval <<'.,.,', 'lib/parser.y', 463
-  def _reduce_99( val, _values, result )
-    result = val[0]
-   result
-  end
-.,.,
-
-module_eval <<'.,.,', 'lib/parser.y', 468
-  def _reduce_100( val, _values, result )
-    result = {:untyped_multiple_attr_object_block => val[0]}
-   result
-  end
-.,.,
-
-module_eval <<'.,.,', 'lib/parser.y', 472
-  def _reduce_101( val, _values, result )
-    result = {:type_identifier => val[0], :untyped_multiple_attr_object_block => val[1]}
-   result
-  end
-.,.,
-
-module_eval <<'.,.,', 'lib/parser.y', 477
-  def _reduce_102( val, _values, result )
-    result = {:multiple_attr_object_block_head => val[0], :keyed_objects => val[1]}
-   result
-  end
-.,.,
-
-module_eval <<'.,.,', 'lib/parser.y', 483
+ # reduce 96 omitted
+
+ # reduce 97 omitted
+
+ # reduce 98 omitted
+
+ # reduce 99 omitted
+
+ # reduce 100 omitted
+
+ # reduce 101 omitted
+
+ # reduce 102 omitted
+
+module_eval <<'.,.,', 'lib/parser.y', 262
   def _reduce_103( val, _values, result )
     @@log.info("SYM_START_DBLOCK: #{val[0]} at #{@filename}:#{@lineno}")
-    result = val[0]
-   result
-  end
-.,.,
-
-module_eval <<'.,.,', 'lib/parser.y', 488
-  def _reduce_104( val, _values, result )
-    result = Array[val[0]]
-   result
-  end
-.,.,
-
-module_eval <<'.,.,', 'lib/parser.y', 492
-  def _reduce_105( val, _values, result )
-    result = (val[0] << val[1])
-   result
-  end
-.,.,
-
-module_eval <<'.,.,', 'lib/parser.y', 498
+   result
+  end
+.,.,
+
+ # reduce 104 omitted
+
+ # reduce 105 omitted
+
+module_eval <<'.,.,', 'lib/parser.y', 270
   def _reduce_106( val, _values, result )
     @@log.info("#{__FILE__}:#{__LINE__}: keyed_object = #{val[0]}, object_block = #{val[2]} at #{@filename}:#{@lineno}")
-    result = {:object_key => val[0], :object_block => val[1]}
-   result
-  end
-.,.,
-
-module_eval <<'.,.,', 'lib/parser.y', 504
+   result
+  end
+.,.,
+
+module_eval <<'.,.,', 'lib/parser.y', 275
   def _reduce_107( val, _values, result )
     @@log.info("object_key: [#{val[1]}] at #{@filename}:#{@lineno}")
-    result = val[1]
-   result
-  end
-.,.,
-
-module_eval <<'.,.,', 'lib/parser.y', 509
-  def _reduce_108( val, _values, result )
-    result = {:untyped_single_attr_object_block => val[0]}
-   result
-  end
-.,.,
-
-module_eval <<'.,.,', 'lib/parser.y', 513
-  def _reduce_109( val, _values, result )
-    result = {:type_identifier => val[0], :untyped_single_attr_object_block => val[1]}
-   result
-  end
-.,.,
-
-module_eval <<'.,.,', 'lib/parser.y', 519
-  def _reduce_110( val, _values, result )
-    @@log.info("#{__FILE__}:#{__LINE__}: single_attr_object_complex_head = #{val[0]} at #{@filename}:#{@lineno}")
-    result = {:single_attr_object_complex_head => val[0]}
-   result
-  end
-.,.,
-
-module_eval <<'.,.,', 'lib/parser.y', 524
-  def _reduce_111( val, _values, result )
-    @@log.info("#{__FILE__}:#{__LINE__}: single_attr_object_complex_head = #{val[0]}, attr_vals = #{val[1]} at #{@filename}:#{@lineno}")
-    result = {:single_attr_object_complex_head => val[0], :attr_vals => val[1]}
-   result
-  end
-.,.,
+   result
+  end
+.,.,
+
+ # reduce 108 omitted
+
+ # reduce 109 omitted
+
+ # reduce 110 omitted
+
+ # reduce 111 omitted
 
  # reduce 112 omitted
 
-module_eval <<'.,.,', 'lib/parser.y', 530
-  def _reduce_113( val, _values, result )
-    @@log.info("#{__FILE__}:#{__LINE__}: untyped_primitive_object_block = #{val[0]} at #{@filename}:#{@lineno}")
-    result = {:untyped_primitive_object_block => val[0]}
-   result
-  end
-.,.,
-
-module_eval <<'.,.,', 'lib/parser.y', 535
-  def _reduce_114( val, _values, result )
-    @@log.info("#{__FILE__}:#{__LINE__}: type_identifier = #{val[0]}, untyped_primitive_object_block = #{val[1]} at #{@filename}:#{@lineno}")
-    result = {:type_identifier => val[0], :untyped_primitive_object_block => val[1]}
-   result
-  end
-.,.,
-
-module_eval <<'.,.,', 'lib/parser.y', 540
+ # reduce 113 omitted
+
+ # reduce 114 omitted
+
+module_eval <<'.,.,', 'lib/parser.y', 287
   def _reduce_115( val, _values, result )
-    @@log.info("#{__FILE__}:#{__LINE__}: primitive_object_block = <#{val[1]}> at #{@filename}:#{@lineno}")
-    result = val[1]
-   result
-  end
-.,.,
-
-module_eval <<'.,.,', 'lib/parser.y', 544
-  def _reduce_116( val, _values, result )
-    result = val[0]
-   result
-  end
-.,.,
-
-module_eval <<'.,.,', 'lib/parser.y', 548
-  def _reduce_117( val, _values, result )
-    result = val[0]
-   result
-  end
-.,.,
-
-module_eval <<'.,.,', 'lib/parser.y', 552
-  def _reduce_118( val, _values, result )
-    result = val[0]
-   result
-  end
-.,.,
-
-module_eval <<'.,.,', 'lib/parser.y', 556
-  def _reduce_119( val, _values, result )
-    result = val[0]
-   result
-  end
-.,.,
-
-module_eval <<'.,.,', 'lib/parser.y', 560
-  def _reduce_120( val, _values, result )
-    result = val[0]
-   result
-  end
-.,.,
-
-module_eval <<'.,.,', 'lib/parser.y', 565
+    @@log.info("#{__FILE__}:#{__LINE__}: primitive_object_block = <#{val[2]}> at #{@filename}:#{@lineno}")
+   result
+  end
+.,.,
+
+ # reduce 116 omitted
+
+ # reduce 117 omitted
+
+ # reduce 118 omitted
+
+ # reduce 119 omitted
+
+ # reduce 120 omitted
+
+module_eval <<'.,.,', 'lib/parser.y', 296
   def _reduce_121( val, _values, result )
     @@log.info("string_value: #{val[0]} at #{@filename}:#{@lineno}")
-    result = val[0]
-   result
-  end
-.,.,
-
-module_eval <<'.,.,', 'lib/parser.y', 570
+   result
+  end
+.,.,
+
+module_eval <<'.,.,', 'lib/parser.y', 300
   def _reduce_122( val, _values, result )
     @@log.info("integer_value: #{val[0]} at #{@filename}:#{@lineno}")
-    result = val[0]
-   result
-  end
-.,.,
-
-module_eval <<'.,.,', 'lib/parser.y', 575
+   result
+  end
+.,.,
+
+module_eval <<'.,.,', 'lib/parser.y', 304
   def _reduce_123( val, _values, result )
     @@log.info("real_value: #{val[0]} at #{@filename}:#{@lineno}")
-    result = val[0]
-   result
-  end
-.,.,
-
-module_eval <<'.,.,', 'lib/parser.y', 580
+   result
+  end
+.,.,
+
+module_eval <<'.,.,', 'lib/parser.y', 308
   def _reduce_124( val, _values, result )
     @@log.info("boolean_value: #{val[0]} at #{@filename}:#{@lineno}")
-    result = val[0]
-   result
-  end
-.,.,
-
-module_eval <<'.,.,', 'lib/parser.y', 585
+   result
+  end
+.,.,
+
+module_eval <<'.,.,', 'lib/parser.y', 312
   def _reduce_125( val, _values, result )
     @@log.info("character_value: #{val[0]} at #{@filename}:#{@lineno}")
-    result = val[0]
-   result
-  end
-.,.,
-
-module_eval <<'.,.,', 'lib/parser.y', 590
+   result
+  end
+.,.,
+
+module_eval <<'.,.,', 'lib/parser.y', 316
   def _reduce_126( val, _values, result )
     @@log.info("date_value: #{val[0]} at #{@filename}:#{@lineno}")
-    result = val[0]
-   result
-  end
-.,.,
-
-module_eval <<'.,.,', 'lib/parser.y', 595
+   result
+  end
+.,.,
+
+module_eval <<'.,.,', 'lib/parser.y', 320
   def _reduce_127( val, _values, result )
     @@log.info("time_value: #{val[0]} at #{@filename}:#{@lineno}")
-    result = val[0]
-   result
-  end
-.,.,
-
-module_eval <<'.,.,', 'lib/parser.y', 600
+   result
+  end
+.,.,
+
+module_eval <<'.,.,', 'lib/parser.y', 324
   def _reduce_128( val, _values, result )
     @@log.info("date_time_value: #{val[0]} at #{@filename}:#{@lineno}")
-    result = val[0]
-   result
-  end
-.,.,
-
-module_eval <<'.,.,', 'lib/parser.y', 605
+   result
+  end
+.,.,
+
+module_eval <<'.,.,', 'lib/parser.y', 328
   def _reduce_129( val, _values, result )
     @@log.info("duration_value: #{val[0]} at #{@filename}:#{@lineno}")
-    result = val[0]
-   result
-  end
-.,.,
-
-module_eval <<'.,.,', 'lib/parser.y', 610
+   result
+  end
+.,.,
+
+module_eval <<'.,.,', 'lib/parser.y', 332
   def _reduce_130( val, _values, result )
     @@log.info("uri_value: #{val[0]} at #{@filename}:#{@lineno}")
-    result = val[0]
    result
   end
@@ -2844,24 +2407,21 @@
  # reduce 145 omitted
 
-module_eval <<'.,.,', 'lib/parser.y', 633
+module_eval <<'.,.,', 'lib/parser.y', 353
   def _reduce_146( val, _values, result )
     @@log.info("V_TYPE_IDENTIFIER: #{val[0]} at #{@filename}:#{@lineno}")
-    result = val[0]
-   result
-  end
-.,.,
-
-module_eval <<'.,.,', 'lib/parser.y', 638
+   result
+  end
+.,.,
+
+module_eval <<'.,.,', 'lib/parser.y', 357
   def _reduce_147( val, _values, result )
     @@log.info("V_GENERIC_TYPE_IDENTIFIER: #{val[0]} at #{@filename}:#{@lineno}")
-    result = val[0]
-   result
-  end
-.,.,
-
-module_eval <<'.,.,', 'lib/parser.y', 644
+   result
+  end
+.,.,
+
+module_eval <<'.,.,', 'lib/parser.y', 362
   def _reduce_148( val, _values, result )
     @@log.info("V_STRING: #{val[0]} at #{@filename}:#{@lineno}")
-    result = val[0]
    result
   end
@@ -2874,39 +2434,9 @@
  # reduce 151 omitted
 
-module_eval <<'.,.,', 'lib/parser.y', 658
-  def _reduce_152( val, _values, result )
-    begin
-      integer = Integer(val[0])
-    rescue
-      raise
-    end
-    result = integer
-   result
-  end
-.,.,
-
-module_eval <<'.,.,', 'lib/parser.y', 667
-  def _reduce_153( val, _values, result )
-    begin
-      integer = Integer(val[0])
-    rescue
-      raise
-    end
-    result = integer
-   result
-  end
-.,.,
-
-module_eval <<'.,.,', 'lib/parser.y', 676
-  def _reduce_154( val, _values, result )
-    begin
-      integer = Integer(val[0])
-    rescue
-      raise
-    end
-    result = - integer
-   result
-  end
-.,.,
+ # reduce 152 omitted
+
+ # reduce 153 omitted
+
+ # reduce 154 omitted
 
  # reduce 155 omitted
@@ -2934,39 +2464,9 @@
  # reduce 166 omitted
 
-module_eval <<'.,.,', 'lib/parser.y', 702
-  def _reduce_167( val, _values, result )
-    begin
-      real = Float(val[0])
-    rescue
-      raise
-    end
-    result = real
-   result
-  end
-.,.,
-
-module_eval <<'.,.,', 'lib/parser.y', 711
-  def _reduce_168( val, _values, result )
-    begin
-      real = Float(val[1])
-    rescue
-      raise
-    end
-    result = real
-   result
-  end
-.,.,
-
-module_eval <<'.,.,', 'lib/parser.y', 720
-  def _reduce_169( val, _values, result )
-    begin
-      real = Float(val[1])
-    rescue
-      raise
-    end
-    result = - real
-   result
-  end
-.,.,
+ # reduce 167 omitted
+
+ # reduce 168 omitted
+
+ # reduce 169 omitted
 
  # reduce 170 omitted
@@ -2994,17 +2494,7 @@
  # reduce 181 omitted
 
-module_eval <<'.,.,', 'lib/parser.y', 740
-  def _reduce_182( val, _values, result )
-    result = true
-   result
-  end
-.,.,
-
-module_eval <<'.,.,', 'lib/parser.y', 744
-  def _reduce_183( val, _values, result )
-    result = false
-   result
-  end
-.,.,
+ # reduce 182 omitted
+
+ # reduce 183 omitted
 
  # reduce 184 omitted
@@ -3100,8 +2590,7 @@
  # reduce 229 omitted
 
-module_eval <<'.,.,', 'lib/parser.y', 808
+module_eval <<'.,.,', 'lib/parser.y', 473
   def _reduce_230( val, _values, result )
     @@log.info("V_ISO8601_DURATION: #{val[0]} at #{@filename}:#{@lineno}")
-    result = val[0]
    result
   end
@@ -3132,8 +2621,7 @@
  # reduce 242 omitted
 
-module_eval <<'.,.,', 'lib/parser.y', 828
+module_eval <<'.,.,', 'lib/parser.y', 492
   def _reduce_243( val, _values, result )
     @@log.info("#{__FILE__}:#{__LINE__}: V_QUALIFIED_TERM_CODE_REF = #{val[0]} at #{@filename}:#{@lineno}")
-    result = val[0]
    result
   end
@@ -3146,8 +2634,7 @@
  # reduce 246 omitted
 
-module_eval <<'.,.,', 'lib/parser.y', 838
+module_eval <<'.,.,', 'lib/parser.y', 501
   def _reduce_247( val, _values, result )
     @@log.info("#{__FILE__}:#{__LINE__}: V_URI = #{val[0]} at #{@filename}:#{@lineno}")
-    result = val[0]
    result
   end
@@ -3234,5 +2721,5 @@
  # reduce 287 omitted
 
-module_eval <<'.,.,', 'lib/parser.y', 907
+module_eval <<'.,.,', 'lib/parser.y', 570
   def _reduce_288( val, _values, result )
     @@log.info("#{__FILE__}:#{__LINE__}, V_ATTRIBUTE_IDENTIFIER = #{val[0]} at #{@filename}")
@@ -3241,5 +2728,5 @@
 .,.,
 
-module_eval <<'.,.,', 'lib/parser.y', 911
+module_eval <<'.,.,', 'lib/parser.y', 574
   def _reduce_289( val, _values, result )
     @@log.info("#{__FILE__}:#{__LINE__}, V_ATTRIBUTE_IDENTIFIER = #{val[0]} at #{@filename}")
@@ -3248,49 +2735,13 @@
 .,.,
 
-module_eval <<'.,.,', 'lib/parser.y', 922
-  def _reduce_290( val, _values, result )
-    result = Range.new(1,1)
-   result
-  end
-.,.,
-
-module_eval <<'.,.,', 'lib/parser.y', 926
-  def _reduce_291( val, _values, result )
-    result = val[3]
-   result
-  end
-.,.,
-
-module_eval <<'.,.,', 'lib/parser.y', 936
-  def _reduce_292( val, _values, result )
-    begin
-      integer = Integer(val[0])
-    rescue
-      raise
-    end
-    result = integer
-   result
-  end
-.,.,
-
-module_eval <<'.,.,', 'lib/parser.y', 946
-  def _reduce_293( val, _values, result )
-    begin
-      from_integer = Integer(val[0])
-      to_integer = Integer(val[2])
-    rescue
-      raise
-    end
-    result = Range.new(from_integer,to_integer)
-   result
-  end
-.,.,
-
-module_eval <<'.,.,', 'lib/parser.y', 951
-  def _reduce_294( val, _values, result )
-    result = OpenEHR::AM::Archetype::Constraint_Model::CARDINALITY.new
-   result
-  end
-.,.,
+ # reduce 290 omitted
+
+ # reduce 291 omitted
+
+ # reduce 292 omitted
+
+ # reduce 293 omitted
+
+ # reduce 294 omitted
 
  # reduce 295 omitted
@@ -3316,10 +2767,5 @@
  # reduce 305 omitted
 
-module_eval <<'.,.,', 'lib/parser.y', 970
-  def _reduce_306( val, _values, result )
-    result = val[3]
-   result
-  end
-.,.,
+ # reduce 306 omitted
 
  # reduce 307 omitted
@@ -3415,52 +2861,17 @@
  # reduce 352 omitted
 
-module_eval <<'.,.,', 'lib/parser.y', 1040
-  def _reduce_353( val, _values, result )
-    result = OpenEHR::AM::Archetype::Constraint_Model::Primitive::C_BOOLEAN.new(:true_valid => true)
-   result
-  end
-.,.,
-
-module_eval <<'.,.,', 'lib/parser.y', 1044
-  def _reduce_354( val, _values, result )
-    result = OpenEHR::AM::Archetype::Constraint_Model::Primitive::C_BOOLEAN.new(:true_valid => false)
-   result
-  end
-.,.,
-
-module_eval <<'.,.,', 'lib/parser.y', 1048
-  def _reduce_355( val, _values, result )
-    result = OpenEHR::AM::Archetype::Constraint_Model::Primitive::C_BOOLEAN.new(:true_valid => true,:false_valid => false)
-   result
-  end
-.,.,
-
-module_eval <<'.,.,', 'lib/parser.y', 1052
-  def _reduce_356( val, _values, result )
-    result = OpenEHR::AM::Archetype::Constraint_Model::Primitive::C_BOOLEAN.new(:true_valid => false,:false_valid => true)
-   result
-  end
-.,.,
-
-module_eval <<'.,.,', 'lib/parser.y', 1057
-  def _reduce_357( val, _values, result )
-    result = val[0]
-   result
-  end
-.,.,
-
-module_eval <<'.,.,', 'lib/parser.y', 1061
-  def _reduce_358( val, _values, result )
-    raise 'Not implemented yet'
-   result
-  end
-.,.,
-
-module_eval <<'.,.,', 'lib/parser.y', 1065
-  def _reduce_359( val, _values, result )
-    raise 'Not implemented yet'
-   result
-  end
-.,.,
+ # reduce 353 omitted
+
+ # reduce 354 omitted
+
+ # reduce 355 omitted
+
+ # reduce 356 omitted
+
+ # reduce 357 omitted
+
+ # reduce 358 omitted
+
+ # reduce 359 omitted
 
  # reduce 360 omitted
@@ -3474,5 +2885,5 @@
  # reduce 364 omitted
 
-module_eval <<'.,.,', 'lib/parser.y', 1078
+module_eval <<'.,.,', 'lib/parser.y', 694
   def _reduce_365( val, _values, result )
     @in_interval = false
@@ -3498,5 +2909,5 @@
  # reduce 373 omitted
 
-module_eval <<'.,.,', 'lib/parser.y', 1100
+module_eval <<'.,.,', 'lib/parser.y', 716
   def _reduce_374( val, _values, result )
     @@log.info("#{__FILE__}:#{__LINE__}, V_ATTRIBUTE_IDENTIFIER = #{word} at #{@filename}")
@@ -3505,10 +2916,5 @@
 .,.,
 
-module_eval <<'.,.,', 'lib/parser.y', 1110
-  def _reduce_375( val, _values, result )
-    result = val[0]
-   result
-  end
-.,.,
+ # reduce 375 omitted
 
  def _reduce_none( val, _values, result )
